package org.sjsustudents;
// define the break can view
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.IntBuffer;
import javax.microedition.khronos.opengles.GL10;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

public class GLExpro {

	private final IntBuffer mVertexBuffer;   // for position
	private final IntBuffer mTextureBuffer;	 // for texture
	   	
	GLExpro(long time)
	{
	   	int one = 65536;
	   	int half = (int)(one/2);
	   	
	   	int timeint = 1; 
	   	
	   	// make the increasing speed effect
	   	for(int i = 0; i < 10; i++){
	   		
	   		timeint = timeint * (int)(time/1000);
	   	}
	   	circlePosition myCircle = new circlePosition(half);    
	   	
	   	// define the breaking can
	   	int vertices[] = 
	   	{
	   		(int)(myCircle.getX(0)/2),            -half+ timeint, (int)myCircle.getZ(0)/2,
	   		(int)(myCircle.getX(0)/2),             half+timeint, (int)myCircle.getZ(0)/2,
	   				
	   		/// angel = PI/8
	   		(int)(myCircle.getX(Math.PI/8)/2),    -half+ timeint, (int)myCircle.getZ(Math.PI/8)/2,
	   		(int)(myCircle.getX(Math.PI/8)/2),     half+ timeint, (int)myCircle.getZ(Math.PI/8)/2,
	   		(int)(myCircle.getX(Math.PI/8, half + timeint)/2),    -half- timeint, (int)myCircle.getZ(Math.PI/8, half + timeint)/2,
	   		(int)(myCircle.getX(Math.PI/8, half + timeint)/2),     half- timeint, (int)myCircle.getZ(Math.PI/8, half - timeint)/2,				
	   				
	   		/// angel = PI/8 * 2
	   		(int)(myCircle.getX(Math.PI/4,half+ timeint)/2),    -half- timeint, (int)myCircle.getZ(Math.PI/4,half+ timeint)/2,
	   		(int)(myCircle.getX(Math.PI/4,half+ timeint)/2),     half- timeint, (int)myCircle.getZ(Math.PI/4,half+ timeint)/2,				
	   		(int)(myCircle.getX(Math.PI/4,half+ timeint*2)/2),    -half+ timeint, (int)myCircle.getZ(Math.PI/4,half+ timeint*2)/2,
	   		(int)(myCircle.getX(Math.PI/4,half+ timeint*2)/2),     half+ timeint, (int)myCircle.getZ(Math.PI/4,half+ timeint*2)/2,	
	   				
	   		/// angel = PI/8 * 3
	   		(int)myCircle.getX(Math.PI/8 * 3,half+ timeint*2)/2, -half+ timeint, (int)myCircle.getZ(Math.PI/8 * 3,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 3,half+ timeint*2)/2,  half+ timeint, (int)myCircle.getZ(Math.PI/8 * 3,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 3,half- timeint*2)/2, -half- timeint*5, (int)myCircle.getZ(Math.PI/8 * 3,half- timeint*2)/2,				
	   		(int)myCircle.getX(Math.PI/8 * 3,half- timeint*2)/2,  half- timeint*5, (int)myCircle.getZ(Math.PI/8 * 3,half- timeint*2)/2,				
	   				
	   		/// angel = PI/8 * 4
	   		(int)myCircle.getX(Math.PI/2,half- timeint*2)/2,    -half- timeint*5, (int)myCircle.getZ(Math.PI/2,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/2,half- timeint*2)/2,     half- timeint*5, (int)myCircle.getZ(Math.PI/2,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/2,half+ timeint*2)/2,    -half- timeint*6, (int)myCircle.getZ(Math.PI/2,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/2,half+ timeint*2)/2,     half- timeint*6, (int)myCircle.getZ(Math.PI/2,half+ timeint*20)/2,				

	   		/// angel = PI/8 * 5
	   		(int)myCircle.getX(Math.PI/8 * 5,half+ timeint*2)/2, -half- timeint*6, (int)myCircle.getZ(Math.PI/8 * 5,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 5,half+ timeint*2)/2,  half- timeint*6, (int)myCircle.getZ(Math.PI/8 * 5,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 5,half- timeint*2)/2, -half- timeint*6, (int)myCircle.getZ(Math.PI/8 * 5,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 5,half- timeint*2)/2,  half- timeint*6, (int)myCircle.getZ(Math.PI/8 * 5,half- timeint*2)/2,	
	   				
	   		/// angel = PI/8 * 6
	   		(int)myCircle.getX(Math.PI/4 * 3,half- timeint*2)/2, -half- timeint*6, (int)myCircle.getZ(Math.PI/4 * 3,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/4 * 3,half- timeint*2)/2,  half- timeint*6, (int)myCircle.getZ(Math.PI/4 * 3,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/4 * 3,half+ timeint*2)/2, -half+ timeint, (int)myCircle.getZ(Math.PI/4 * 3,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/4 * 3,half+ timeint*2)/2,  half+ timeint, (int)myCircle.getZ(Math.PI/4 * 3,half+ timeint*2)/2,	
	   				
	   		/// angel = PI/8 * 7
	   		(int)myCircle.getX(Math.PI/8 * 7,half+ timeint*2)/2, -half- timeint, (int)myCircle.getZ(Math.PI/8 * 7,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 7,half+ timeint*2)/2,  half- timeint, (int)myCircle.getZ(Math.PI/8 * 7,half+ timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 7)/2, half- timeint*3, (int)myCircle.getZ(Math.PI/8 * 7)/2,
	   		(int)myCircle.getX(Math.PI/8 * 7)/2,  half- timeint*3, (int)myCircle.getZ(Math.PI/8 * 7)/2,				
	   							
	   		/// angel = PI 
	   		(int)myCircle.getX(Math.PI,half+ timeint*3)/2,       -half- timeint*3, (int)myCircle.getZ(Math.PI,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI,half+ timeint*3)/2,        half- timeint*3, (int)myCircle.getZ(Math.PI,half+ timeint*3)/2,	
	   		(int)myCircle.getX(Math.PI,half- timeint*2)/2,       -half- timeint*4, (int)myCircle.getZ(Math.PI,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI,half- timeint*2)/2,        half- timeint*4, (int)myCircle.getZ(Math.PI,half- timeint*2)/2,	
	   				
	   		/// angel = PI/8 * 9
	   		(int)myCircle.getX(Math.PI/8 * 9,half- timeint*2)/2, -half- timeint*4, (int)myCircle.getZ(Math.PI/8 * 9,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 9,half- timeint*2)/2,  half- timeint*4, (int)myCircle.getZ(Math.PI/8 * 9,half- timeint*2)/2,
	   		(int)myCircle.getX(Math.PI/8 * 9,half+ timeint*3)/2, -half+ timeint*4, (int)myCircle.getZ(Math.PI/8 * 9,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 9,half+ timeint*3)/2,  half+ timeint*4, (int)myCircle.getZ(Math.PI/8 * 9,half+ timeint*3)/2,				
	   				
	   		/// angel = PI/4 * 5
	   		(int)myCircle.getX(Math.PI/4 * 5,half+ timeint*3)/2, -half+ timeint*4, (int)myCircle.getZ(Math.PI/4 * 5,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/4 * 5,half+ timeint*3)/2,  half+ timeint*4, (int)myCircle.getZ(Math.PI/4 * 5,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/4 * 5,half+ timeint*3)/2, -half+ timeint, (int)myCircle.getZ(Math.PI/4 * 5,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/4 * 5,half+ timeint*3)/2,  half+ timeint, (int)myCircle.getZ(Math.PI/4 * 5,half+ timeint*3)/2,
	   				
	   		/// angel = PI/8 * 11
	   		(int)myCircle.getX(Math.PI/8 * 11,half+ timeint*3)/2, -half+ timeint, (int)myCircle.getZ(Math.PI/8 * 11,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 11,half+ timeint*3)/2,  half+ timeint, (int)myCircle.getZ(Math.PI/8 * 11,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 11)/2, -half+ timeint*5, (int)myCircle.getZ(Math.PI/8 * 11)/2,
	   		(int)myCircle.getX(Math.PI/8 * 11)/2,  half+ timeint*5, (int)myCircle.getZ(Math.PI/8 * 11)/2,				
	   				
	   		/// angel = PI/4 * 6
	   		(int)myCircle.getX(Math.PI/4 * 6)/2, -half+ timeint*5, (int)myCircle.getZ(Math.PI/4 * 6)/2,
	   		(int)myCircle.getX(Math.PI/4 * 6)/2,  half+ timeint*5, (int)myCircle.getZ(Math.PI/4 * 6)/2,
	   		(int)myCircle.getX(Math.PI/4 * 6,half+ timeint*3)/2, -half- timeint*3, (int)myCircle.getZ(Math.PI/4 * 6,half+ timeint*3)/2,
	  		(int)myCircle.getX(Math.PI/4 * 6,half+ timeint*3)/2,  half- timeint*3, (int)myCircle.getZ(Math.PI/4 * 6,half+ timeint*3)/2,
	   				
	   		/// angel = PI/8 * 13
	   		(int)myCircle.getX(Math.PI/8 * 13,half+ timeint*3)/2, -half- timeint*3, (int)myCircle.getZ(Math.PI/8 * 13,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 13,half+ timeint*3)/2,  half- timeint*3, (int)myCircle.getZ(Math.PI/8 * 13,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 13)/2, -half+ timeint*7, (int)myCircle.getZ(Math.PI/8 * 13)/2,
	   		(int)myCircle.getX(Math.PI/8 * 13)/2,  half+ timeint*7, (int)myCircle.getZ(Math.PI/8 * 13)/2,				
	   				
	   		/// angel = PI/4 * 7
	   		(int)myCircle.getX(Math.PI/4 * 7)/2, -half+ timeint*7, (int)myCircle.getZ(Math.PI/4 * 7)/2,
	   		(int)myCircle.getX(Math.PI/4 * 7)/2,  half+ timeint*7, (int)myCircle.getZ(Math.PI/4 * 7)/2,
	   		(int)myCircle.getX(Math.PI/4 * 7,half+ timeint*3)/2, -half- timeint*8, (int)myCircle.getZ(Math.PI/4 * 7,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/4 * 7,half+ timeint*3)/2,  half- timeint*8, (int)myCircle.getZ(Math.PI/4 * 7,half+ timeint*3)/2,
	   				
	   		/// angel = PI/8 * 15
	   		(int)myCircle.getX(Math.PI/8 * 15,half+ timeint*3)/2, -half- timeint*8, (int)myCircle.getZ(Math.PI/8 * 15,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 15,half+ timeint*3)/2,  half- timeint*8, (int)myCircle.getZ(Math.PI/8 * 15,half+ timeint*3)/2,
	   		(int)myCircle.getX(Math.PI/8 * 15)/2, -half+ timeint*5, (int)myCircle.getZ(Math.PI/8 * 15)/2,
	   		(int)myCircle.getX(Math.PI/8 * 15)/2,  half+ timeint*5, (int)myCircle.getZ(Math.PI/8 * 15)/2,				
	   				
	   		/// angel = PI/4 * 8
	   		(int)myCircle.getX(Math.PI * 2)/2,   -half+ timeint*5, (int)myCircle.getZ(Math.PI * 2)/2,
	   		(int)myCircle.getX(Math.PI * 2)/2,    half+ timeint*5, (int)myCircle.getZ(Math.PI * 2)/2,

	   	};
	   		
	   	ByteBuffer vbb = ByteBuffer.allocateDirect(vertices.length*4);
	   		
	   	vbb.order(ByteOrder.nativeOrder());
	   	mVertexBuffer = vbb.asIntBuffer();
	   	mVertexBuffer.put(vertices);
	   	mVertexBuffer.position(0);
	   		
	   	int side = one/16;
	   	
	   	//map the surface
	   	int texCoords[] = {
	   			
	   		0,       one, 0,      0, side,     one, side,   0,
	   		side,    one, side,   0, side*2,   one, side*2, 0,	   				
	   		side*2,  one, side*2, 0, side*3,   one, side*3, 0,	
	  		side*3,  one, side*3, 0, side*4,   one, side*4, 0,
	   		side*4,  one, side*4, 0, side*5,   one, side*5, 0,	
	   		side*5,  one, side*5, 0, side*6,   one, side*6, 0,	
	   		side*6,  one, side*6, 0, side*7,   one, side*7, 0,	
	   		side*7,  one, side*7, 0, side*8,   one, side*8, 0,		
	   		side*8,  one, side*8, 0, side*9,   one, side*9, 0,	
	   		side*9,  one, side*9, 0, side*10,  one, side*10, 0,
	   		side*10, one, side*10, 0, side*11, one, side*11, 0,
	   		side*11, one, side*11, 0, side*12, one, side*12, 0,
	   		side*12, one, side*12, 0, side*13, one, side*13, 0,
	   		side*13, one, side*13, 0, side*14, one, side*14, 0,		
	   		side*14, one, side*14, 0, side*15, one, side*15, 0,
	   		side*15, one, side*15, 0, side*16, one, side*16, 0

	   	};
	   		
	   	ByteBuffer tbb = ByteBuffer.allocateDirect(texCoords.length * 4);
	   	tbb.order(ByteOrder.nativeOrder());
	   	mTextureBuffer = tbb.asIntBuffer();
	   	mTextureBuffer.put(texCoords);
	   	mTextureBuffer.position(0);
	   		   		
	   	}
		
	   	static void loadTexture(GL10 gl, Context context, int resource)
	   	{
	   		Bitmap bmp = BitmapFactory.decodeResource(
	   				context.getResources(), resource);
	   		ByteBuffer bb = extract(bmp);
	   		load(gl, bb, bmp.getWidth(), bmp.getHeight());
	   	}
	   	
	   	static ByteBuffer extract(Bitmap bmp)
	   	{
	   	   ByteBuffer bb = ByteBuffer.allocateDirect(bmp.getHeight() * bmp.getWidth() * 4);
	   	   bb.order(ByteOrder.BIG_ENDIAN);
	   	   IntBuffer ib = bb.asIntBuffer();
	   	   
	   	   // Convert ARGB ->RGBA
	   	   
	   	   for(int y = bmp.getHeight() - 1; y > -1; y--)
	   	   {
	   		 for(int x =0; x < bmp.getWidth(); x++)
	   		 {
	   		  int pix = bmp.getPixel(x, bmp.getHeight() -y - 1);
	   		  int alpha = ((pix >>24) & 0xFF);
	   		  int red = ((pix >> 16) & 0xFF);
	   		  int green = ((pix >> 8) & 0xFF);
	   		  int blue = ((pix) & 0xFF);
	   		  
	   		  ib.put(red << 24 | green << 16 | blue << 8 | alpha);
	   		 } 
	   	   }
	   	   bb.position(0);
	   	   return bb;
	   	}
	   	
	   	static void load(GL10 gl, ByteBuffer bb, int width, int height)
	   	{
	   		int[] tmp_tex = new int[1];
	   		gl.glGenTextures(1, tmp_tex, 0);
	   		int tex = tmp_tex[0];
	   		
	   		//Load it up
	   		gl.glBindTexture(GL10.GL_TEXTURE_2D, tex);
	   		gl.glTexImage2D(GL10.GL_TEXTURE_2D, 0, GL10.GL_RGBA, width, height, 0, GL10.GL_RGBA, GL10.GL_UNSIGNED_BYTE, bb);
	   		gl.glTexParameterx(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, GL10.GL_LINEAR);
	   	}
	   	
	   	void draw(GL10 gl)
	   	{
	   		gl.glVertexPointer(3, GL10.GL_FIXED, 0, mVertexBuffer);
	   		gl.glColor4f(1, 1, 1, 1);
	   		gl.glNormal3f(0, -1, 0);
	   		
	   		for(int i = 0; i < 16; i++){
	   			
	   			gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, i*4, 4);
	   		}
	   	
	   		gl.glTexCoordPointer(2, GL10.GL_FIXED, 0, mTextureBuffer);
	   	}
}
