package org.sjsustudents;

import android.app.Activity;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;

public class Hw4 extends Activity implements OnClickListener {
	
	 private ViewGroup vg = null;
	 private GLView myGLview = null;
	 MediaPlayer mp = null;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	  	
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        vg = (ViewGroup)findViewById(R.id.mylayout);

        if(vg != null){
        	 
        	myGLview = new GLView(this,0);
        	vg.addView(myGLview, 7);
        	
        }
        bringallview();       
        mp = MediaPlayer.create(Hw4.this, R.raw.coke);
        mp.start();   
    
     }
    public void onPause(){
    	super.onPause();
    	mp.stop();
    }
    // set up listeners, put all button/text view to the front   
    public void bringallview(){
    	
        View button;

        button = this.findViewById(R.id.left);
        button.bringToFront();
        button.setOnClickListener(this);

        button = this.findViewById(R.id.right);
        button.bringToFront();
        button.setOnClickListener(this);

        button = this.findViewById(R.id.up);
        button.bringToFront();
        button.setOnClickListener(this);

        button = this.findViewById(R.id.down);
        button.bringToFront();
        button.setOnClickListener(this);

        button = this.findViewById(R.id.zoomin);
        button.bringToFront();
        button.setOnClickListener(this);

        button = this.findViewById(R.id.zoomout);
        button.bringToFront();
        button.setOnClickListener(this);
        
        button = this.findViewById(R.id.breakb);
        button.bringToFront();
        button.setOnClickListener(this);
        
        button = this.findViewById(R.id.score);
        button.bringToFront();
    }
    // define the buttons' behavior
    public void onClick(View v)
    {
    	// remove the previous view
    	vg.removeView(myGLview);
    	
    	// pick the corresponding view
    	switch(v.getId())
    	{
	
    	case R.id.left:
    		
    		myGLview = new GLView(this,1);

		   	break;
	   
    	case R.id.right:
    		
    		myGLview = new GLView(this,2);

		   	break;
       	   
    	case R.id.up:
    		myGLview = new GLView(this,3);	
    		break;
		   
    	case R.id.down:
    		myGLview = new GLView(this,4);	
    		break;	

    	case R.id.zoomin:
    		myGLview = new GLView(this,5);	
    		break;	
		   
    	case R.id.zoomout:
    		myGLview = new GLView(this,6);
    		break; 
    		
    	case R.id.breakb:
    		myGLview = new GLView(this,7);
    		break; 
 	     
    	}
    	// add the new view
    	vg.addView(myGLview, 7);
    	// bring all other views to the front
    	bringallview();
    } 
}