package org.sjsustudents;
//define the normal view for top and bottom of the can
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.IntBuffer;
import javax.microedition.khronos.opengles.GL10;

public class TopBottom {
	
	private final IntBuffer mVertexBuffer2;
	   	
	TopBottom ()
	{
	     int one = 65536;
	     int half = one/2;
	     circlePosition myCircle = new circlePosition(half);
	   		
	     int vertices[] = 
	     {
	          //Top
	       	0,half,0,	
	       	(int)myCircle.getX(Math.PI/8 * 0)/2,  half, (int)myCircle.getZ(Math.PI/8 * 0)/2,
	       	(int)myCircle.getX(Math.PI/8 * 1)/2,  half, (int)myCircle.getZ(Math.PI/8 * 1)/2,	
	       	(int)myCircle.getX(Math.PI/8 * 2)/2,  half, (int)myCircle.getZ(Math.PI/8 * 2)/2,    		
	       	(int)myCircle.getX(Math.PI/8 * 3)/2,  half, (int)myCircle.getZ(Math.PI/8 * 3)/2,   	
	       	(int)myCircle.getX(Math.PI/8 * 4)/2,  half, (int)myCircle.getZ(Math.PI/8 * 4)/2,    	
	       	(int)myCircle.getX(Math.PI/8 * 5)/2,  half, (int)myCircle.getZ(Math.PI/8 * 5)/2,  	
	        (int)myCircle.getX(Math.PI/8 * 6)/2,  half, (int)myCircle.getZ(Math.PI/8 * 6)/2,
	        (int)myCircle.getX(Math.PI/8 * 7)/2,  half, (int)myCircle.getZ(Math.PI/8 * 7)/2,
	        (int)myCircle.getX(Math.PI/8 * 8)/2,  half, (int)myCircle.getZ(Math.PI/8 * 8)/2,
	        (int)myCircle.getX(Math.PI/8 * 9)/2,  half, (int)myCircle.getZ(Math.PI/8 * 9)/2,
	        (int)myCircle.getX(Math.PI/8 * 10)/2,  half, (int)myCircle.getZ(Math.PI/8 * 10)/2,
	        (int)myCircle.getX(Math.PI/8 * 11)/2,  half, (int)myCircle.getZ(Math.PI/8 * 11)/2,
	        (int)myCircle.getX(Math.PI/8 * 12)/2,  half, (int)myCircle.getZ(Math.PI/8 * 12)/2,
	        (int)myCircle.getX(Math.PI/8 * 13)/2,  half, (int)myCircle.getZ(Math.PI/8 * 13)/2,
	        (int)myCircle.getX(Math.PI/8 * 14)/2,  half, (int)myCircle.getZ(Math.PI/8 * 14)/2,
	        (int)myCircle.getX(Math.PI/8 * 15)/2,  half, (int)myCircle.getZ(Math.PI/8 * 15)/2,        
	        (int)myCircle.getX(Math.PI/8 * 16)/2,  half, (int)myCircle.getZ(Math.PI/8 * 16)/2, 

	        //bottom
	       	0,-half,0,	  
	       	(int)myCircle.getX(Math.PI/8 * 0)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 0)/2,
	       	(int)myCircle.getX(Math.PI/8 * 1)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 1)/2,	
	       	(int)myCircle.getX(Math.PI/8 * 2)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 2)/2, 		
	       	(int)myCircle.getX(Math.PI/8 * 3)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 3)/2,   	
	       	(int)myCircle.getX(Math.PI/8 * 4)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 4)/2,  	
	       	(int)myCircle.getX(Math.PI/8 * 5)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 5)/2,  	
	        (int)myCircle.getX(Math.PI/8 * 6)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 6)/2,
	        (int)myCircle.getX(Math.PI/8 * 7)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 7)/2,
	        (int)myCircle.getX(Math.PI/8 * 8)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 8)/2,
	        (int)myCircle.getX(Math.PI/8 * 9)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 9)/2,
	        (int)myCircle.getX(Math.PI/8 * 10)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 10)/2,
	        (int)myCircle.getX(Math.PI/8 * 11)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 11)/2,
	        (int)myCircle.getX(Math.PI/8 * 12)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 12)/2,
	        (int)myCircle.getX(Math.PI/8 * 13)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 13)/2,
	        (int)myCircle.getX(Math.PI/8 * 14)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 14)/2,
	        (int)myCircle.getX(Math.PI/8 * 15)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 15)/2,        
	        (int)myCircle.getX(Math.PI/8 * 16)/2,  -half, (int)myCircle.getZ(Math.PI/8 * 16)/2,        
	     };
	   		
	     ByteBuffer vbb = ByteBuffer.allocateDirect(vertices.length*4);
	     vbb.order(ByteOrder.nativeOrder());
	     mVertexBuffer2 = vbb.asIntBuffer();
	     mVertexBuffer2.put(vertices);
	     mVertexBuffer2.position(0);
	        
	}

	void draw(GL10 gl)
	{
	   	 gl.glVertexPointer(3, GL10.GL_FIXED, 0, mVertexBuffer2);
	   	 gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
	     gl.glColor4f(1, 1, 1, 1);
	     gl.glNormal3f(0, 0, 1);
	     gl.glDrawArrays(GL10.GL_TRIANGLE_FAN, 0, 18);
	     gl.glDrawArrays(GL10.GL_TRIANGLE_FAN, 18, 18);
	}
}
