package org.sjsustudents;

import android.content.Context;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

public class GLView extends SurfaceView implements SurfaceHolder.Callback {

	private int myoption = 0;
    GLView(Context context, int option)
    {
    	super(context);
    	getHolder().addCallback(this);
    	getHolder().setType(SurfaceHolder.SURFACE_TYPE_GPU); 	 
    	this.myoption = option;

    }

    private GLThread glThread;  // use this thread to control 
    	   
    public void surfaceCreated(SurfaceHolder holder)
    {
    	glThread = new GLThread(this, myoption);
    	glThread.start();
    }
    	 
    public void surfaceDestroyed(SurfaceHolder holder)
    {
    	glThread.requestExitAndWait();
    	glThread = null;
    }

    public void surfaceChanged(SurfaceHolder holder, int format, int w, int h)
    {

    }

}
